DESTDIR			:= /
INSTALL_FAKE_ROOT	:= $(DESTDIR)
LIB_DIR			:= /usr/lib
INSTALL_LIB_DIR		:= $(INSTALL_FAKE_ROOT)$(LIB_DIR)
INSTALL_INCL_DIR	:= $(INSTALL_FAKE_ROOT)/usr/include

ifdef DEBUG
DEBUG_FLAGS = -DDEBUG -ggdb -gdwarf-2 -g3
OPT_FLAGS =
else
OPT_FLAGS = -O2
endif

ifdef SPEED_TEST
DEBUG_FLAGS += -DGOSTC_ASYM_TEST_SPEED
endif

CC	:= gcc
ARFLAGS	:= rcs
CFLAGS	+= $(OPT_FLAGS) \
     -fno-common -fno-strict-aliasing \
    -Wstrict-prototypes -Wmissing-prototypes -Wsign-compare -Wmissing-declarations \
    -Wshadow -Wpointer-arith -Wcast-align -Wpacked \
    -Wformat -Wno-format-extra-args -Wformat-security \
    -fstack-protector \
    -Wall $(DEBUG_FLAGS)

ifndef NO_PARANOID
CFLAGS += -Werror -Wall -ansi -pedantic -pedantic-errors
else
CFLAGS += -std=c99
endif

# -Wformat-nonliteral -Wformat=2
CXXFLAGS += $(OPT_FLAGS) \
    -fno-common -Wsign-compare \
    -Wshadow -Wpointer-arith -Wcast-align -Wpacked -Wall -Werror $(DEBUG_FLAGS)
CPPFLAGS += -MD -D_GNU_SOURCE
#-D_FORTIFY_SOURCE=2
LDFLAGS	+= -z defs -zrelro

# Shared libraries specific CFLAGS
CFLAGS_SO := -fpic
