#ifndef _GOSTC_SYM_H_
#define _GOSTC_SYM_H_

#include "gostc_common.h"

typedef struct _gostc_sym_mac_t
{
	uint32_t A; /* Current A */
	uint32_t B; /* Current B */
	uint8_t  temp[16]; /* The tail */
	uint32_t left; /* tail size */
	uint32_t total;
/* If changed - don't forget to change gostc_sym_key(un)wrap */
} gostc_sym_mac_t;


#ifdef __cplusplus
extern "C" {
#endif

/* Electronic code-book mode */
void gostc_sym_ECB(uint32_t *inbuf, uint32_t *outbuf, uint32_t *key, 
	uint32_t *mask, uint32_t* CurUZ);

void gostc_sym_ECBBack(uint32_t *inbuf, uint32_t *outbuf, uint32_t *key, 
	uint32_t *mask, uint32_t* CurUZ);


/* Counter Mode */
extern void gostc_sym_Gamma(uint8_t* pIn, uint8_t* pOut, void* pSync, uint32_t nSize,
	uint32_t* k1, uint32_t* k1m, uint32_t* CurUZ);


/* Gamma feedback mode */
extern void gostc_sym_EncryptCFB(const uint8_t* pPlain, uint8_t* pCrypto, const void* pSync,
	uint32_t nSize, uint32_t* k1, uint32_t* k1m, uint32_t* CurUZ);

extern void gostc_sym_DecryptCFB(const uint8_t* pCrypto, uint8_t* pPlain, const void* pSync,
	uint32_t nSize, uint32_t* k1, uint32_t* k1m, uint32_t* CurUZ);


extern void gostc_sym_setUZ(uint8_t * shortUZ, uint32_t* longUZ);


/* Imit */

extern void* gostc_sym_MacOpen(void);

extern int gostc_sym_DoMac(void* ctx, void* info,uint32_t size,uint32_t* aKey,
	uint32_t* aMask,uint32_t* CurUZ);
/* ret 0-ok, 1-error */

extern int gostc_sym_MacClose(void* ctx, void *mac, uint32_t* aKey, 
	uint32_t* aMask,uint32_t* CurUZ);
/* Frees ctx. ret 0-ok, 1-error */

extern int gostc_sym_MacClose_plain(void* ctx, void *mac, uint32_t* aKey, 
	uint32_t* aMask,uint32_t* CurUZ);
/* Does not free and does not clear ctx. ret 0-ok, 1-error */

extern void gostc_sym_MacReset(void* ctx);
/* Clears context (does not free) */

extern void gostc_sym_C16( uint32_t* A, uint32_t* B,uint32_t *key, uint32_t *mask, 
	uint32_t* CurUZ);


/* Other */
extern void gostc_sym_ModC(void* data); /* data - 8 bytes */

#ifdef __cplusplus
}
#endif


#endif

