#ifndef _GOSTC_SYM_KEYWRAP_H_
#define _GOSTC_SYM_KEYWRAP_H_

#include "gostc_common.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int gostc_sym_keywrap(uint8_t* openkey_in, uint8_t* kek_in, uint8_t* ukm, int uz, 
	uint8_t* enckey_out, uint8_t* imit_out);
/* */
/* Wraps openkey_in (32 B) by kek_in (32 B) using random value ukm (8 B)
 * and calculates imit_out (4 B)
 * enckey_out - 32 B
 * uz - 1-CproSetA, 2-B, 3-C, 4-D, 5-Z
 * Ret: !0 - err 
 */

extern int gostc_sym_keyunwrap(uint8_t* enckey_in, uint8_t* kek_in, uint8_t* imit_in, 
	uint8_t* ukm, int uz, uint8_t* openkey_out);
/* Unwraps the key and checks imit 
 * Ret: 0-ok, 1-imit failed, >1-error 
 */

extern int gostc_sym_divers65(void *key_in, void* ukm, int uz, void *key_out);
/* Performs key diversification RFC4357 6.5 
 * Ret: 0-ok, !0-err
 */

#ifdef __cplusplus
}
#endif


#endif

