#include "gostc_asym_vko.h"

/*****************************************************************************/
/* /////NUMBER: 1 - xchga, 2 - xchgb/////// */
int gostc_vko_LoadParams(int Number, void ** CSPstruct)
{
    if (!CSPstruct) 
	    return GCVKO_ERROR_EMPTYPOINTER;
    if((Number<=0)||(Number>2))
	return GCVKO_ERROR_NUMOF_CSP;
    *CSPstruct =  gostc_asym_LoadParams(Number*2);
    if(!*CSPstruct)
	return GCVKO_ERROR_LOADPARAMS;
    return 0;
}
/*****************************************************************************/
int gostc_vko_FreeParams(void * CSPstruct)
{
    if(!CSPstruct)
	return GCVKO_ERROR_EMPTYPOINTER;
    gostc_asym_FreeParams(CSPstruct);
    return 0;
}
/*****************************************************************************/
int gostc_vko_GenSecretKey(void *CSPstruct, unsigned char* rnd32b, void* SecretKey)
{
	int rc;

	if (!CSPstruct || !rnd32b || !SecretKey) 
		return GCVKO_ERROR_EMPTYPOINTER;

	rc = gostc_asym_GenSecretKey(CSPstruct, rnd32b, SecretKey);
	if (rc == 2) 
		return GCVKO_MORE_RANDOM_DATA;
	if (!rc) return GCVKO_ERROR_GENSECRETKEY;
	return 0;
}
/*****************************************************************************/
int gostc_vko_GenOpenKey(void *CSPstruct, void* SecretKey, void *OpenKey)
{
    if(!CSPstruct)
	return GCVKO_ERROR_EMPTYPOINTER;
    if(!SecretKey)
	return GCVKO_ERROR_EMPTYSECRETKEY;
    if(!gostc_asym_GenPublicKey(CSPstruct,SecretKey,OpenKey))
	return GCVKO_ERROR_GENOPENKEY;
    return 0;
}
/*****************************************************************************/
int gostc_vko_GenCommonKey(void *CSPstruct, void * SecretKey, void * OpenKey, void* UKM,void *CommonKey)
{
    if(!CSPstruct)
	return GCVKO_ERROR_EMPTYPOINTER;
    if(!SecretKey)
	return GCVKO_ERROR_EMPTYSECRETKEY;
    if(!OpenKey)
	return GCVKO_ERROR_EMPTYOPENKEY;
    if(!gostc_asym_GenDFHKey(CSPstruct,SecretKey,OpenKey,UKM,CommonKey))
	return 8;

    return 0;
}
/*****************************************************************************/

