#include "gostc_hash.h"
#include <stdio.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdint.h>
#include <string.h>
#include <strings.h>


/*****************************************************************************/
void mydump(void* ptr,int len)
{
	int i, j;
	unsigned char c, *buf;
	unsigned int cc;

	j = 0;
	buf = ptr;
	for (i = 0; i < len; i++) {
		if (j > 15) {
			j = 0;
			printf("\n");
		}
		c = buf[i];
		cc = c;
		printf("%.2X ", cc);
		j++;
	}
	printf("\n");
}
/*****************************************************************************/
int main(int argc, char** argv)
{
	void *h = NULL;
	int f = -1;
	uint8_t* buf = NULL;
	struct stat sb;
	int len;
	uint8_t b32[32];

	if (argc != 2) {
		printf("Usage: calchash <file>\n");
		return 1;
	}
	f = open(argv[1], O_RDONLY);
	if (f < 0) {
		printf("Error: Can't read file '%s'\n", argv[1]);
		return 1;
	}
	bzero(&sb, sizeof(sb));
	if (fstat(f, &sb)) {
		printf("Error: Can't stat file '%s'\n", argv[1]);
		return 1;
	}
	len = sb.st_size;
	if (len > 4000000000) {
		printf("Error: Too large file\n");
		return 1;
	}
	buf = malloc(len);
	if (!buf) {
		printf("Error: Out of memory\n");
		return 1;
	}
	if (read(f, buf, len) != len) {
		printf("Error: Failed to read file\n");
		return 1;
	}
	h = gostc_hash_open();
	gostc_hash_do(h, buf, len);
	gostc_hash_close(h, b32);

	printf("GOST R 34.11-94 hash:\n");
	mydump(b32, 32);

	return 0;

/* No free and close - bydlo-kod. :) */

}

