#include <stdio.h>
#include <stdint.h>


static unsigned char hash_uz_cpro[64] = {
	0x5A,0x47,0x77,0x1D,
	0xF4,0xAF,0x66,0x3E,
	0x45,0x7C,0x24,0xA4,
	0x06,0xCE,0x4B,0x91,
	0x28,0x09,0xD9,0x57,
	0xD1,0xF4,0x9C,0xB0,
	0xB3,0x21,0xF2,0x45,
	0x97,0x80,0x0A,0xFA,
	0x1D,0xE3,0xA1,0x83,
	0x7C,0x1B,0x18,0x6C,
	0x6E,0x65,0x50,0x78,
	0x30,0x52,0xBE,0xEF,
	0xC9,0xD6,0x8F,0xD6,
	0xE2,0xBA,0xED,0x02,
	0xAB,0x98,0xC3,0x29,
	0x8F,0x3D,0x35,0xCB
};

#define _lrotl(x,y) ((x<<(y))|(x>>(32-(y))))


static void hash_setUZ(uint8_t* shortUZ, uint32_t* longUZ)
{
	uint32_t oneElement;
	int i,j;

	for(i = 0;i<16;i++)
	{
	 for(j = 0;j<16;j++)
	  {
	    oneElement = (shortUZ[i*4]&0xf0)|(shortUZ[j*4]&0xf);
	    longUZ[i*16+j] = _lrotl(oneElement,11);

	    oneElement = (shortUZ[i*4+1]&0xf0)|(shortUZ[j*4+1]&0xf);
	    longUZ[256+i*16+j] = _lrotl(oneElement,(11+8));

	    oneElement = (shortUZ[i*4+2]&0xf0)|(shortUZ[j*4+2]&0xf);
	    longUZ[512+i*16+j] = _lrotl(oneElement,(11+16));

	    oneElement = (shortUZ[i*4+3]&0xf0)|(shortUZ[j*4+3]&0xf);
	    longUZ[768+i*16+j] = _lrotl(oneElement,(11+24-32));
	  }
	}
	oneElement = 0;
}


int main(int argc, char** argv)
{
	uint32_t longuz[1024];
	int i, j;

	hash_setUZ(hash_uz_cpro, longuz);
	printf("uint32_t longUZ[1024] = {\n");
	for (i = 0; i < 1024; i += 8) {
		for (j = 0; j < 8; j++) {
			printf("0x%.8X, ", longuz[i + j]);
		}
		printf("\n");
	}
	printf("};\n");
	return 0;
}

