#include <stdint.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "gostc_asym.h"


/*****************************************************************************/
void mydump(void* ptr,int len)
{
	int i, j;
	unsigned char c, *buf;
	unsigned int cc;

	j = 0;
	buf = ptr;
	for (i = 0; i < len; i++) {
		if (j > 15) {
			j = 0;
			printf("\n");
		}
		c = buf[i];
		cc = c;
		printf("%.2X ", cc);
		j++;
	}
	printf("\n");
}
/*****************************************************************************/
int main(int argc, char**argv)
{
	uint8_t privkey[64];
	void* pars = NULL;
	int parset;
	int rc;
	int f;
	uint8_t rnd[64];

	if (argc != 2) {
		printf("Usage: mkpriv <par>\n");
		printf(
"par = 1-TestGost, 2-CproA(XchA), 3-CproB, 4-CproC(XchB),\n"
"      5-TC26-512Test, 6-TC26-512A, 7-TC26-512B\n");
		return 1;
	}
	parset = atoi(argv[1]);
	if ((parset < 1) || (parset > 7)) {
		printf("Wrong par\n");
		return 1;
	}
	pars = gostc_asym_LoadParams(parset);

	rc = 2;
	while (rc == 2) {
		f = open("/dev/urandom", O_RDONLY);
		if (f > -1) {
			if (read(f, rnd, 64) != 64) f = -1;
		}
		if (f < 0) {
			printf("Failed to read /dev/urandom\n");
			return 1;
		}
		rc = gostc_asym_GenSecretKey(pars, rnd, privkey);
		/* ret: 0-err, 1-ok, 2-more rnd needed */
	}
	if (rc != 1) {
		printf("GenSecretKey error:%d\n", rc);
		return 1;
	}
	mydump(privkey, parset > 4 ? 64 : 32);
	return 0;
}
